Max Sum Plus Plus HDU - 1024(dp)

Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem. 

Given a consecutive number sequence S  1, S  2, S  3, S  4 ... S  x, ... S n (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ S  x ≤ 32767). We define a function sum(i, j) = S  i + ... + S  j (1 ≤ i ≤ j ≤ n). 

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i  1, j  1) + sum(i  2, j  2) + sum(i  3, j  3) + ... + sum(i  m, j  m) maximal (i  x ≤ i  y ≤ j  x or i  x ≤ j  y ≤ j  x is not allowed). 

But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(i  x, j  x)(1 ≤ x ≤ m) instead. ^_^ 
InputEach test case will begin with two integers m and n, followed by n integers S  1, S  2, S  3 ... S  n
Process to the end of file. 
OutputOutput the maximal summation described above in one line. 
Sample Input
1 3 1 2 3
2 6 -1 4 -2 3 -2 3
Sample Output
6
8


        
  
Hint
Huge input, scanf and dynamic programming is recommended.


题意:给你n个点,你从中选m个不相交子段,要求值最大

解:我们可以设  dp [ i ] [ j ] 为 在选取第 j 项的基础上把前 j 项分解为 i 段

我们 设  dp[ i - 1 ] [ 0 ] 到  dp[ i -1 ] [ j - 1] 的最大值定义为 ma[ i - 1 ] [ j  - 1 ]

那么 dp[ i ] [ j ]  =max (    dp[ i ] [  j-1 ] +a [  j ]  ,  ma [ i - 1 ] [ j - 1 ] +a [ j ]   )

显然只有两种情况 1   他和他的前一个数是同一子段   2  找到最大的 i -1 段 ,把  j 视为单独一段

因为我们不知道m的大小 我们可以用滚动数组

#include<stdio.h>
#include<string>
#include<string.h>
#include<algorithm>
#include<iostream>
const int inf=0x3f3f3f3f;
using namespace std;
int dp[1100000];
int ma[1100000];
int  a[1100000];
int mma;
int n,m;
int main()
{
   while(~scanf("%d%d",&m,&n))
   {
       memset(ma,0,sizeof(ma));
       memset(dp,0,sizeof(dp));
       for(int i=1;i<=n;i++)
        scanf("%d",&a[i]);
       for(int i=1;i<=m;i++)
       {
           mma=-inf;
           for(int j=i;j<=n;j++)
           {
               dp[j]=max(dp[j-1]+a[j],ma[j-1]+a[j]); 
               ma[j-1]=mma;
               mma=max(mma,dp[j]);
           }
       }
       printf("%d\n",mma);
   }
}


猜你喜欢

转载自blog.csdn.net/dsaghjkye/article/details/80230015